function binstr = aenc_01( sequence, probs )
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here

    % Step 1: Compute cumulative distribution function
    cdf = cumsum(probs);
    % Make the vector contain interval boundaries
    cdf = [ 0, cdf ];
    disp(cdf);
    cdf_base = cdf;
    
    for symbol=sequence
        % Index of the symbol in `probs`
        s_index = symbol-'A'+1;
        % Probability interval for the symbol
        prob0 = cdf(s_index);
        prob1 = cdf(s_index+1);
        % Symbol is a character -> %c
        % Index is a decimal number -> %d
        fprintf('cdf_base: '); 
        fprintf('%f ', cdf_base);
        fprintf('\ncdf: '); 
        fprintf('%f ', cdf);
        fprintf('\n%c - %d - (%8.6f,%8.6f)\n\n', ...
            symbol, s_index, prob0, prob1);
        % Update the scale by symbol probability
        cdf_base = cdf_base * probs(s_index);
        cdf = prob0 + cdf_base;
    end
    
    % Interval limits
    fprintf('Interval limits: (%f, %f)\n\n', prob0, prob1);
    
    % Initialize the returned value
    binstr='';

    % Are we inside the interval for our message?
    inside_interval = false;
    % The first tested number is 1/2, then 1/4, 1/8, ...
    denominator = 2;
    % Initialise the output value
    n = 0;
    % Now gradually refine our estimate by bisection until we are in
    while ~inside_interval
        fval = 1/denominator;
        ftest = n + fval;
        if ftest > prob1
            fprintf('1/%d is not there, %f is over max\n', denominator, ftest);
            binstr = [ binstr '0' ];
        else
            n = ftest;
            fprintf('1/%d is there, %f is not over max\n', denominator, ftest);
            binstr = [ binstr '1' ];
        end
        inside_interval = (n > prob0) && (n < prob1);
        denominator = 2*denominator;
    end
    
    
end

